
import pdb,sys,os,subprocess,shutil

Mat=sys.argv[1]
lambda_cut_motif=float(sys.argv[2])
outputdir=sys.argv[3]
inputseqname=sys.argv[4]
S=sys.argv[5]
C=sys.argv[6]
randomseq=sys.argv[7]

java="java"
try:
	#pdb.set_trace()
	subprocess.call([java,"-version"])
	
	os.system(java+" -cp code getLambda "+randomseq+" "+Mat+" "+str(lambda_cut_motif)+" "+outputdir)
except:
	os.system("python code/get_lambda.py "+randomseq+" "+Mat+" "+str(lambda_cut_motif)+" "+outputdir)

## preparing and precessing PWMs and lambda
f=open(Mat,'r')
lf=f.readlines()
f.close()
lf="".join(lf)
lf=lf.split(">")[1:]
matrix=lf


f=open("%s_lambda"%(Mat),'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item.split("\t") for item in lf]
lam=lf

for i in range(len(matrix)):
	matrix[i]=matrix[i].split("\n")
	tmp=matrix[i][0].split("\t")
	matrix[i][0]=">M"+str(i)+"\t"+lam[i][0]+"\t"+lam[i][1]+"\t"+tmp[1]
	matrix[i]="\n".join(matrix[i])
	#pbd.set_trace()
matrix="\n".join(matrix)
f=open("%s"%(Mat),'w')
f.write(matrix)
f.close()

for i in range(len(lam)):
	lam[i]=">M"+str(i)+"\t"+lam[i][1]+"\t"+"NA"
lam="\n".join(lam)
f=open("%s_lambda"%(Mat),'w')
f.write(lam)
f.close()

FN=inputseqname.split(os.sep)[-1]
## run crm.py to get the motif combinations
os.system("python code/crm.py -i "+'"%s"'%(inputseqname)+" -o "+outputdir+"_mod"+" -s "+str(S)+" -c "+str(C)+" -m "+"%s"%(Mat)+" -l "+"%s_lambda"%(Mat)+" -f txt"+" -d N")
########################################################################
os.system('python code/get_tfbs_adjust.py %s_mod/%s_MotifHits_4_non_redundant %s_mod/%s_MotifHitsPositions_4_non_redundant "%s" %s %s'%(outputdir,FN,outputdir,FN,inputseqname,Mat,outputdir))
#pdb.set_trace()
f=open(outputdir+"_mod/mod",'r')
lf=f.readlines()
f.close()
lf=[item.strip() for item in lf]
lf=[item for item in lf if item!="()"]
lf=[item.split("\t") for item in lf]
for i in range(len(lf)):
	lf[i][0]=lf[i][0].split(" ")
	for j in range(len(lf[i][0][:-1])):
		lf[i][0][j]="M"+lf[i][0][j]
	lf[i][0]=" ".join(lf[i][0])
	lf[i]="\t".join(lf[i])
lf="\n".join(lf)
#inputseqname=inputseqname.split("/")[-1]
f=open(outputdir+"/"+FN+".mc.adjusted",'w')
f.write(lf)
f.close()
os.system('python code/tfbs_mc.py %s_mod/%s_MotifHits_4_non_redundant %s_mod/%s_MotifHitsPositions_4_non_redundant %s/%s.mc.adjusted %s %s %s' %(outputdir,FN,outputdir,FN,outputdir,FN,inputseqname,Mat,outputdir))
shutil.rmtree(outputdir+"_mod")
os.remove(outputdir+"/"+FN+".motifs.adjusted_lambda")
